' TextBarlines-LP.vbs - Proof of concept - Lawrie Pardy.
' Usage: run the script with 0 or 1 space delimited arguments.  The argument is to specify which 
' user font is defined with the barlines font.  You can also use a "help" argument.
' I.E. to use the User5 font use no argument OR a "5" as the is the script default.
' Any other argument between 1 and 6 will use that user font.
'
'          Lots of comments included to prove to myself I have some idea of what I think I'm doing
'
Option Explicit                                                           ' Require explicit declaration of variables
Dim lin, alin, objArgs, args, i, j(6), k, a1, bartype, fontnum, rnum, flag ' Create initial variables old - ones: barset,
'          Select the set of alternative barlines required
'	   If you want to change this, be my guest.
' Set the number of the user font here. E.G a 5 ends up becoming "User5" later in the script.  
' This can be overridden on the command line.
fontnum = 5

' Read any arguments from the command line
Set objArgs = WScript.Arguments
If objArgs.Count <> 0 Then                                                        ' make sure we actually have at least one argument
     If LCase(objArgs.Item(0)) = "help" Then
         Dim hlp(2)                                                               ' Create an array to hold the help text
             hlp(0) = "Optional User font number may be entered on the command line (1 to 6)"
             hlp(1) = "Else the script defaults to font User5"
             hlp(2) = "This script randomly selects appropriate bars from the selected font"
         MsgBox Join(hlp, vbLf), 0 , "Help - Optional arguments:": WScript.Quit   ' Quit if the help text is displayed.
     End If
     If Instr ("123456",objArgs.Item(0)) then fontnum = objArgs.Item(0)
End If

Dim reminder(7)                                                                   ' Create an array to hold the reminder text
    reminder(0) = "Be sure to make user font " & fontnum & " the correct font (E.G. SwingBars)"
    reminder(1) = "at the same size or slightly greater than the staff metric.  The default"
    reminder(2) = "user font can be changed by editing the fontnum variable in this script."
    reminder(3) = " "
    reminder(4) = "Please also note that the ending barline is not an object so the script cannot"
    reminder(5) = "identify it.  Workaround is to either have no ending bar property on the staff"
    reminder(6) = "and place one manually OR place an appropriate bar with a system break immediately"
    reminder(7) = "prior to the end of the staff.  This will also justify the staff better."
MsgBox Join(reminder, vbLf), 0 , "Reminder - Correct font assignment"

'Create an array that contains the character locations in the font for the replacement barlines
'The first item in each row (item 0) is the text type - NOT valid for "Single" as this doesn't
'actually exist in the clip text.  The second item in each row (item 1) is the character for the 
'required barline in the specified font.  E.G. In SwingBars.ttf, the  "B" character
'is actually a double barline, the "C" is a Section Open etc..  
'Each column is considered a "barset" (I.E. Item 1 in each row is barset 1)
Dim decorated(6,3)
    decorated(0,0) = "Double"
    decorated(0,1) = "A"
    decorated(0,2) = "H"
    decorated(0,3) = "O"
    decorated(1,0) = "SectionOpen"
    decorated(1,1) = "B"
    decorated(1,2) = "I"
    decorated(1,3) = "P"
    decorated(2,0) = "SectionClose"
    decorated(2,1) = "C"
    decorated(2,2) = "J"
    decorated(2,3) = "Q"
    decorated(3,0) = "LocalRepeatOpen"
    decorated(3,1) = "D"
    decorated(3,2) = "K"
    decorated(3,3) = "R"
    decorated(4,0) = "LocalRepeatClose"
    decorated(4,1) = "E"
    decorated(4,2) = "L"
    decorated(4,3) = "S"
    decorated(5,0) = "MasterRepeatOpen"
    decorated(5,1) = "F"
    decorated(5,2) = "M"
    decorated(5,3) = "T"
    decorated(6,0) = "MasterRepeatClose"
    decorated(6,1) = "G"
    decorated(6,2) = "N"
    decorated(6,3) = "U"
    
Dim singlebars(19)
    singlebars(0) = ")"
    singlebars(1) = "!"
    singlebars(2) = "@"
    singlebars(3) = "#"
    singlebars(4) = "$"
    singlebars(5) = "%"
    singlebars(6) = "^"
    singlebars(7) = "&"
    singlebars(8) = "*"
    singlebars(9) = "("
    for i = 10 to 19
     singlebars(i) = i - 10
    next
    
Dim doflag(1)
    doflag(0) = 1
    doflag(1) = 1
 
    
Randomize                                           ' initialise the random number generator
'barset = 1                                          ' initialise barset
'If objArgs.Count Then barset = objArgs.Item(0)      ' set the barset to the number specified on the command line
Do Until WScript.StdIn.AtEndOfStream                ' Read the clip - line by line
 lin = WScript.StdIn.ReadLine
 a1 = Split(lin & "|", "|")                         'Create an array called "a1" from the line (lin)
 i = 0: bartype = 0 : flag = vbTrue                 'initialise some variables
 doflag(0) = doflag(1) : doflag(1) = 1
 If Instr (lin,"Visibility:Never") Then flag = vbFalse 'Check for hidden objects 
 If Instr (lin,"User" & fontnum) Then doflag(1) = 0 ' Check for if there is already a text barline
  If flag Then 
  If doflag(0) Then
  If a1(1) = "Bar" Then                             ' Check to see if we have a barline here
   i = 1
   If Instr(a1(2),"Style") Then                     ' If we have a barline see if it is non default I.E. listed in "decorated"
     for k = 0 to 6
       if Instr(a1(2),decorated(k,0)) Then
         rnum = CInt(Int((3 - 1 + 1) * Rnd() + 1)) 'Create a randum number between 1 and 3 for variable decorated barline selection
         bartype = decorated(k,(rnum))             ' This line randomly selects from 3 possible decorated barlines
       End If
     next
   Else 
    rnum = CInt(Int((19 - 0 + 1) * Rnd() + 0))      'Create a randum number between 0 and 9 for variable single barline selection
    bartype = singlebars(rnum)                     ' This line randomly selects from 10 possible single barlines
   End If
  End If
  End If
 End If                                            ' Finish of need to figure out a check for if there is already a text barline
 If i Then                                         ' Construct the elements of the j array in order to create 
  j(0) = "|Text"                                   ' the text required to create the text barline element
  j(1) = "Text:" & """" & bartype & """"           ' 4 quotes are necessary to make 1 quote - go figure...
  j(2) = "Font:User" & fontnum                     ' This is where we set the user font required
  j(3) = "Pos:0"
  j(4) = "wide:N"
  j(5) = "Justify:Center"
  j(6) = "Placement:AtNextNote"
  alin = Join(j, "|")                              ' Create a line for the text barline
  WScript.StdOut.WriteLine alin                    ' Write the line out
 End If
 WScript.StdOut.WriteLine lin                      ' Write the original line out ready for the next one
Loop                                               ' loop de outer loop

' eof TextBarlines-LP.vbs - Proof of concept
